package com.qmth.distributed.print.business.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.distributed.print.business.bean.dto.CourseWeightFormDto;
import com.qmth.distributed.print.business.bean.params.ObeCourseWeightParam;
import com.qmth.distributed.print.business.bean.result.ObeCourseWeightResult;
import com.qmth.distributed.print.business.entity.ObeCourseWeight;
import com.qmth.teachcloud.common.entity.SysUser;

import java.util.List;

/**
 * <p>
 * 课程权重设置 服务类
 * </p>
 *
 * @author CaoZixuan
 * @since 2024-02-22
 */
public interface ObeCourseWeightService extends IService<ObeCourseWeight> {

    /**
     * 查询课程权重
     *
     * @param obeCourseOutlineId 教学课程id
     * @return 课程权重信息
     */
    ObeCourseWeightResult findCourseWeight(Long obeCourseOutlineId);

    /**
     * 保存课程权重
     *
     * @param obeCourseWeightParam 课程权重参数
     * @param requestUser       请求人
     */
    void saveCourseWeight(ObeCourseWeightParam obeCourseWeightParam, SysUser requestUser);

    /**
     * 删除课程权重设置
     *
     * @param obeCourseOutlineId 教学课程id
     */
    void deleteCourseWeight(Long obeCourseOutlineId);
}