package com.qmth.distributed.print.api;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.distributed.print.business.bean.dto.obe.CourseRequirementMatrixDto;
import com.qmth.distributed.print.business.bean.dto.obe.MatrixRequirementDto;
import com.qmth.distributed.print.business.bean.dto.obe.MatrixSubRequirementDto;
import com.qmth.distributed.print.business.bean.dto.report.ReportCourseEvaluationResultDto;
import com.qmth.distributed.print.business.bean.result.ScoreResult;
import com.qmth.distributed.print.business.entity.TRBasicInfo;
import com.qmth.distributed.print.business.service.TRBasicInfoService;
import com.qmth.distributed.print.business.service.TRExamStudentService;
import com.qmth.teachcloud.common.contant.SystemConstant;
import com.qmth.teachcloud.common.util.JacksonUtil;
import com.qmth.teachcloud.common.util.Result;
import com.qmth.teachcloud.common.util.ResultUtil;
import io.swagger.annotations.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;
import java.util.Objects;

/**
 * <p>
 * obe专业达成度报表 前端控制器
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
@Api(tags = "obe专业达成度报表Controller")
@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX + SystemConstant.PREFIX_URL_OBE)
public class ObeReportController {
    private final static Logger log = LoggerFactory.getLogger(ObeReportController.class);

    @Resource
    TRBasicInfoService trBasicInfoService;

    @Resource
    TRExamStudentService trExamStudentService;

    @ApiOperation(value = "毕业要求达成度雷达报表")
    @RequestMapping(value = "/requirements/radar/report", method = RequestMethod.POST)
    @ApiResponses({@ApiResponse(code = 200, message = "毕业要求达成度雷达报表", response = ScoreResult.class)})
    @Aac(auth = false)
    public Result requirementsRadarReport(@ApiParam(value = "培养方案ID", required = true) @RequestParam(required = false) Long cultureProgramId) {
        String s = "[{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"cultureProgramId\":null,\"obeCourseId\":null,\"obeRequirementId\":null,\"obeSubRequirementId\":null,\"content\":null,\"intensity\":null,\"courseCode\":\"1400\",\"courseName\":\"微积分\",\"courseSortNum\":0,\"requirementSortNum\":0,\"subRequirementSortNum\":0,\"canEdit\":true,\"requirements\":[{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"工程知识\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077696\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"1-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"问题分析\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077697\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"2-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"设计/开发解决方案\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077698\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"3-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"研究\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077699\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"4-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"使用工具\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077700\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"5-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"工程与社会\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077701\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"6-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"环境和可持续发展\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077702\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"7-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"职业规范\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077703\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"8-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"个人与团队\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077704\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"9-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"沟通\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077705\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"10-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"项目管理\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077706\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"11-1\",\"orgId\":null,\"content\":null}]},{\"id\":null,\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"终身学习\",\"orgId\":null,\"subRequirements\":[{\"id\":\"533285303218077707\",\"createId\":null,\"createTime\":null,\"updateId\":null,\"updateTime\":null,\"schoolId\":null,\"name\":\"12-1\",\"orgId\":null,\"content\":null}]}]}]";
//        CourseRequirementMatrixDto courseRequirementMatrixDto = JSONObject.parseObject(s, CourseRequirementMatrixDto.class);
        List<CourseRequirementMatrixDto> courseRequirementMatrixDtoList = JSONArray.parseArray(s, CourseRequirementMatrixDto.class);
        log.info("courseRequirementMatrixDto:{}", JacksonUtil.parseJson(courseRequirementMatrixDtoList));
        Long examId = 510450135071723520L;
        Long teachCourseId = 510826410978316288L;
        if (!CollectionUtils.isEmpty(courseRequirementMatrixDtoList)) {
            for (CourseRequirementMatrixDto c : courseRequirementMatrixDtoList) {
                TRBasicInfo trBasicInfo = trBasicInfoService.queryBasicInfo(examId, c.getCourseCode(), null, teachCourseId);
                if (Objects.nonNull(trBasicInfo)) {
                    ReportCourseEvaluationResultDto reportCourseEvaluationResultDto = Objects.nonNull(trBasicInfo.getCourseEvaluationResult()) ? JSONObject.parseObject(trBasicInfo.getCourseEvaluationResult(), ReportCourseEvaluationResultDto.class) : null;
                    log.info("reportCourseEvaluationResultDto:{}", JacksonUtil.parseJson(reportCourseEvaluationResultDto));
                }
                List<MatrixRequirementDto> matrixRequirementDtoList = c.getRequirements();
                if (!CollectionUtils.isEmpty(matrixRequirementDtoList)) {
                    for (MatrixRequirementDto matrixRequirementDto : matrixRequirementDtoList) {
                        List<MatrixSubRequirementDto> matrixSubRequirementDtoList = matrixRequirementDto.getSubRequirements();
                        if (!CollectionUtils.isEmpty(matrixSubRequirementDtoList)) {
                            for (MatrixSubRequirementDto matrixSubRequirementDto : matrixSubRequirementDtoList) {
                                if (Objects.nonNull(matrixSubRequirementDto.getScale())) {

                                }
                            }
                        }
                    }
                }
            }
        }
        return ResultUtil.ok(true);
    }

    @ApiOperation(value = "毕业要求达成度详情报表")
    @RequestMapping(value = "/requirements/detail/report", method = RequestMethod.POST)
    @ApiResponses({@ApiResponse(code = 200, message = "毕业要求达成度详情报表", response = ScoreResult.class)})
    @Aac(auth = false)
    public Result requirementsDetailReport(@ApiParam(value = "培养方案ID", required = true) @RequestParam(required = false) Long cultureProgramId) {
        return ResultUtil.ok(true);
    }


    @ApiOperation(value = "毕业要求达成度学生报表")
    @RequestMapping(value = "/requirements/student/report", method = RequestMethod.POST)
    @ApiResponses({@ApiResponse(code = 200, message = "毕业要求达成度学生报表", response = ScoreResult.class)})
    @Aac(auth = false)
    public Result requirementsStudentReport(@ApiParam(value = "培养方案ID", required = true) @RequestParam(required = false) Long cultureProgramId) {
        return ResultUtil.ok(true);
    }
}
